
#property copyright "POWER GRAPH"
#property link      "POWER GRAPH"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 SeaGreen
#property indicator_color2 FireBrick

//
//
//
//
//

#property  indicator_width1  2
#property  indicator_width2  2

//
//
//
//
//
//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    Lb        = 3;

//
//
//
//
//

double hi[];
double lo[];
double Hlv[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
 IndicatorBuffers(3);
   SetIndexBuffer(0,hi); SetIndexDrawBegin(0,Lb+1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,lo); SetIndexDrawBegin(1,Lb+1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Hlv);
   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
     //
     //
     //
     //
     //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  Gann HiLo activator bars");
 return(0);
}
//
//
//
//
//

int deinit(){  return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{       
  // Locks based on the date - Begins
   if (DayOfYear() > 160)
   {
      Alert("Validaty Expired - To extend the service - please contact Power Graph");
      return (-1);
      
   }  

   if (Year() > 2014)
   {
      Alert("Validaty Expired - To extend the service - please contact Power Graph");
      return (-1);
      
   }  
  // Locks based on the date - Ends


   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (returnBars)  { hi[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {

       for(i=limit;i>=0;i--)
       {
          Hlv[i] = Hlv[i+1];
             if(Close[i]>iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1)) Hlv[i] =  1;
             if(Close[i]<iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW,i+1))  Hlv[i] = -1;
      
             if(Hlv[i] == -1)
                  { lo[i] = High[i]; hi[i] = Low[i]; }
             else { hi[i] = High[i]; lo[i] = Low[i]; }
       }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   
   for (i=limit; i>=0; i--)
   {
   
       int y = iBarShift(NULL,timeFrame,Time[i]);
         hi[i]  = EMPTY_VALUE;
         lo[i]  = EMPTY_VALUE;
         Hlv[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,2,y); 
         
         if(Hlv[i] == -1)
                  { lo[i] = High[i]; hi[i] = Low[i]; }
             else { hi[i] = High[i]; lo[i] = Low[i]; }
    }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
      


